#include "types.h"

StringSet instructions;

class Instructions
{
public:
    Instructions();
};

Instructions::Instructions()
{
instructions << "AAD" << "AAM" << "AAS" << "ADC" << "ADCX" << "ADD" << "ADDSD"
        << "ADDSS" << "ADDSUBPS" << "ADOX" << "AESDEC" << "AESDECLAST" << "AESENCLAST"
        << "AESIMC" << "AESKEYGENASSIST" << "AND" << "ANDN" << "ANDNPD" << "ANDNPS"
        << "ANDPD" << "ANDPS" << "ARPL" << "BB0_RESET" << "BB1_RESET" << "BEXTR"
        << "BLENDPS" << "BLENDVPD" << "BLENDVPS" << "BLSI" << "BLSMSK" << "BLSR"
        << "BOUND" << "BSF" << "BSR" << "BSWAP" << "BT" << "BTC" << "BTR" << "BTS"
        << "BZHI" << "CALL" << "CBW" << "CDQ" << "CDQE" << "CLAC" << "CLC" << "CLD"
        << "CLFLUSH" << "CLGI" << "CLI" << "CLTS" << "CMC" << "CMOVA" << "CMOVAE"
        << "CMOVB" << "CMOVBE" << "CMOVC" << "CMOVE" << "CMOVG" << "CMOVGE" << "CMOVL"
        << "CMOVLE" << "CMOVNA" << "CMOVNAE" << "CMOVNB" << "CMOVNBE" << "CMOVNC"
        << "CMOVNE" << "CMOVNG" << "CMOVNGE" << "CMOVNL" << "CMOVNLE" << "CMOVNO"
        << "CMOVNP" << "CMOVNS" << "CMOVNZ" << "CMOVO" << "CMOVP" << "CMOVPE"
        << "CMOVPO" << "CMOVS" << "CMOVZ" << "CMP" << "CMPEQPD" << "CMPEQPS"
        << "CMPEQSD" << "CMPEQSS" << "CMPLEPD" << "CMPLEPS" << "CMPLESD" << "CMPLESS"
        << "CMPLTPD" << "CMPLTPS" << "CMPLTSD" << "CMPLTSS" << "CMPNEQPD" << "CMPNEQPS"
        << "CMPNEQSD" << "CMPNEQSS" << "CMPNLEPD" << "CMPNLEPS" << "CMPNLESD" << "CMPNLESS"
        << "CMPNLTPD" << "CMPNLTPS" << "CMPNLTSD" << "CMPNLTSS" << "CMPORDPD" << "CMPORDPS"
        << "CMPORDSD" << "CMPORDSS" << "CMPPD" << "CMPPS" << "CMPSB" << "CMPSD"
        << "CMPSQ" << "CMPSS" << "CMPSW" << "CMPUNORDPD" << "CMPUNORDPS" << "CMPUNORDSD"
        << "CMPUNORDSS" << "CMPXCHG" << "CMPXCHG16B" << "CMPXCHG486" << "CMPXCHG8B" << "COMISD"
        << "COMISS" << "CPUID" << "CPU_READ" << "CPU_WRITE" << "CQO" << "CRC32"
        << "CVTDQ2PD" << "CVTDQ2PS" << "CVTPD2DQ" << "CVTPD2PI" << "CVTPD2PS" << "CVTPI2PD"
        << "CVTPI2PS" << "CVTPS2DQ" << "CVTPS2PD" << "CVTPS2PI" << "CVTSD2SI" << "CVTSD2SS"
        << "CVTSI2SD" << "CVTSI2SS" << "CVTSS2SD" << "CVTSS2SI" << "CVTTPD2DQ" << "CVTTPD2PI"
        << "CVTTPS2DQ" << "CVTTPS2PI" << "CVTTSD2SI" << "CVTTSS2SI" << "CWD" << "CWDE"
        << "DAA" << "DAS" << "DB" << "DD" << "DDQ" << "DEC" << "DIV" << "DIVPD" << "DIVPS"
        << "DIVSD" << "DIVSS" << "DMINT" << "DO" << "DPPD" << "DPPS" << "DQ" << "DT" << "DW"
        << "DY" << "EMMS" << "ENTER" << "EQU" << "EXTRACTPS" << "EXTRQ" << "F2XM1" << "FABS"
        << "FADD" << "FADDP" << "FBLD" << "FBSTP" << "FCHS" << "FCLEX" << "FCMOVB" << "FCMOVBE"
        << "FCMOVE" << "FCMOVNB" << "FCMOVNBE" << "FCMOVNE" << "FCMOVNU" << "FCMOVU" << "FCOM"
        << "FCOMI" << "FCOMIP" << "FCOMP" << "FCOMPP" << "FCOS" << "FDECSTP" << "FDISI"
        << "FDIV" << "FDIVP" << "FDIVR" << "FDIVRP" << "FEMMS" << "FENI" << "FFREE" << "FFREEP"
        << "FIADD" << "FICOM" << "FICOMP" << "FIDIV" << "FIDIVR" << "FILD" << "FIMUL"
        << "FINCSTP" << "FINIT" << "FIST" << "FISTP" << "FISTTP" << "FISUB" << "FISUBR"
        << "FLD" << "FLD1" << "FLDCW" << "FLDENV" << "FLDL2E" << "FLDL2T" << "FLDLG2"
        << "FLDLN2" << "FLDPI" << "FLDZ" << "FMUL" << "FMULP" << "FNCLEX" << "FNDISI"
        << "FNENI" << "FNINIT" << "FNOP" << "FNSAVE" << "FNSTCW" << "FNSTENV" << "FNSTSW"
        << "FPATAN" << "FPREM" << "FPREM1" << "FPTAN" << "FRNDINT" << "FRSTOR" << "FSAVE"
        << "FSCALE" << "FSETPM" << "FSIN" << "FSINCOS" << "FSQRT" << "FST" << "FSTCW"
        << "FSTENV" << "FSTP" << "FSTSW" << "FSUB" << "FSUBP" << "FSUBR" << "FSUBRP"
        << "FTST" << "FUCOM" << "FUCOMI" << "FUCOMIP" << "FUCOMP" << "FUCOMPP" << "FWAIT"
        << "FXAM" << "FXCH" << "FXRSTOR64" << "FXSAVE" << "FXSAVE64" << "FXTRACT" << "FYL2X"
        << "FYL2XP1" << "HADDPD" << "HADDPS" << "HINT_NOP0" << "HINT_NOP1" << "HINT_NOP10"
        << "HINT_NOP11" << "HINT_NOP12" << "HINT_NOP13" << "HINT_NOP14" << "HINT_NOP15"
        << "HINT_NOP16" << "HINT_NOP17" << "HINT_NOP18" << "HINT_NOP19" << "HINT_NOP2"
        << "HINT_NOP20" << "HINT_NOP21" << "HINT_NOP22" << "HINT_NOP23" << "HINT_NOP24"
        << "HINT_NOP25" << "HINT_NOP26" << "HINT_NOP27" << "HINT_NOP28" << "HINT_NOP29"
        << "HINT_NOP3" << "HINT_NOP30" << "HINT_NOP31" << "HINT_NOP32" << "HINT_NOP33"
        << "HINT_NOP34" << "HINT_NOP35" << "HINT_NOP36" << "HINT_NOP37" << "HINT_NOP38"
        << "HINT_NOP39" << "HINT_NOP4" << "HINT_NOP40" << "HINT_NOP41" << "HINT_NOP42"
        << "HINT_NOP43" << "HINT_NOP44" << "HINT_NOP45" << "HINT_NOP46" << "HINT_NOP47"
        << "HINT_NOP48" << "HINT_NOP49" << "HINT_NOP5" << "HINT_NOP50" << "HINT_NOP51"
        << "HINT_NOP52" << "HINT_NOP53" << "HINT_NOP54" << "HINT_NOP55" << "HINT_NOP56"
        << "HINT_NOP57" << "HINT_NOP58" << "HINT_NOP59" << "HINT_NOP6" << "HINT_NOP60"
        << "HINT_NOP61" << "HINT_NOP62" << "HINT_NOP63" << "HINT_NOP7" << "HINT_NOP8"
        << "HINT_NOP9" << "HLT" << "HSUBPD" << "HSUBPS" << "IBTS" << "ICEBP" << "IDIV"
        << "IMUL" << "IN" << "INC" << "INCBIN" << "INSB" << "INSD" << "INSERTPS"
        << "INSERTQ" << "INSW" << "INT" << "INT01" << "INT03" << "INT1" << "INT3"
        << "INTO" << "INVD" << "INVEPT" << "INVLPG" << "INVLPGA" << "INVPCID" << "INVVPID"
        << "IRET" << "IRETD" << "IRETQ" << "IRETW" << "JA" << "JAE" << "JB" << "JBE" << "JC"
        << "JCXZ" << "JE" << "JECXZ" << "JG" << "JGE" << "JL" << "JLE" << "JMP" << "JMPE"
        << "JNA" << "JNAE" << "JNB" << "JNBE" << "JNC" << "JNE" << "JNG" << "JNGE" << "JNL"
        << "JNLE" << "JNO" << "JNP" << "JNS" << "JNZ" << "JO" << "JP" << "JPE" << "JPO"
        << "JRCXZ" << "JS" << "JZ" << "LAHF" << "LAR" << "LDDQU" << "LDMXCSR" << "LDS"
        << "LEA" << "LEAVE" << "LES" << "LFENCE" << "LFS" << "LGDT" << "LGS" << "LIDT"
        << "LLDT" << "LLWPCB" << "LMSW" << "LOADALL" << "LOADALL286" << "LODSB" << "LODSD"
        << "LODSQ" << "LODSW" << "LOOP" << "LOOPE" << "LOOPNE" << "LOOPNZ" << "LOOPZ"
        << "LSL" << "LSS" << "LTR" << "LWPINS" << "LWPVAL" << "LZCNT" << "MAXPD" << "MAXPS"
        << "MAXSD" << "MAXSS" << "MFENCE" << "MINPD" << "MINPS" << "MINSD" << "MINSS"
        << "MONITOR" << "MONTMUL" << "MOV" << "MOVAPD" << "MOVAPS" << "MOVBE" << "MOVD"
        << "MOVDDUP" << "MOVDQ2Q" << "MOVDQA" << "MOVDQU" << "MOVHLPS" << "MOVHPD" << "MOVHPS"
        << "MOVLHPS" << "MOVLPD" << "MOVLPS" << "MOVMSKPD" << "MOVMSKPS" << "MOVNTDQ"
        << "MOVNTDQA" << "MOVNTI" << "MOVNTPD" << "MOVNTPS" << "MOVNTQ" << "MOVNTSD"
        << "MOVNTSS" << "MOVQ" << "MOVQ2DQ" << "MOVSB" << "MOVSD" << "MOVSHDUP" << "MOVSLDUP"
        << "MOVSQ" << "MOVSS" << "MOVSW" << "MOVSX" << "MOVSXD" << "MOVUPD" << "MOVUPS"
        << "MOVZX" << "MPSADBW" << "MUL" << "MULPD" << "MULPS" << "MULSD" << "MULSS" << "MULX"
        << "MWAIT" << "NEG" << "NOP" << "NOT" << "OR" << "ORPD" << "ORPS" << "OUT" << "OUTSB"
        << "OUTSD" << "OUTSW" << "PABSB" << "PABSD" << "PABSW" << "PACKSSDW" << "PACKSSWB"
        << "PACKUSDW" << "PACKUSWB" << "PADDB" << "PADDD" << "PADDQ" << "PADDSB" << "PADDSIW"
        << "PADDSW" << "PADDUSB" << "PADDUSW" << "PADDW" << "PALIGNR" << "PAND" << "PANDN"
        << "PAUSE" << "PAVEB" << "PAVGB" << "PAVGUSB" << "PAVGW" << "PBLENDVB" << "PBLENDW"
        << "PCLMULHQHQDQ" << "PCLMULHQLQDQ" << "PCLMULLQHQDQ" << "PCLMULQDQ" << "PCMPEQB"
        << "PCMPEQD" << "PCMPEQQ" << "PCMPEQW" << "PCMPESTRI" << "PCMPESTRM" << "PCMPGTB"
        << "PCMPGTD" << "PCMPGTQ" << "PCMPGTW" << "PCMPISTRI" << "PCMPISTRM" << "PDEP"
        << "PDISTIB" << "PEXT" << "PEXTRB" << "PEXTRD" << "PEXTRQ" << "PEXTRW" << "PF2ID"
        << "PFACC" << "PFADD" << "PFCMPEQ" << "PFCMPGE" << "PFCMPGT" << "PFMAX" << "PFMIN"
        << "PFMUL" << "PFNACC" << "PFPNACC" << "PFRCP" << "PFRCPIT1" << "PFRCPIT2"
        << "PFRSQIT1" << "PFRSQRT" << "PFRSQRTV" << "PFSUB" << "PFSUBR" << "PHADDD"
        << "PHADDSW" << "PHADDW" << "PHMINPOSUW" << "PHSUBD" << "PHSUBSW" << "PHSUBW"
        << "PI2FD" << "PI2FW" << "PINSRB" << "PINSRD" << "PINSRQ" << "PINSRW" << "PMACHRIW"
        << "PMADDUBSW" << "PMADDWD" << "PMAGW" << "PMAXSB" << "PMAXSD" << "PMAXSW" << "PMAXUB"
        << "PMAXUD" << "PMAXUW" << "PMINSB" << "PMINSD" << "PMINSW" << "PMINUB" << "PMINUD"
        << "PMINUW" << "PMOVMSKB" << "PMOVSXBD" << "PMOVSXBQ" << "PMOVSXBW" << "PMOVSXDQ"
        << "PMOVSXWD" << "PMOVSXWQ" << "PMOVZXBD" << "PMOVZXBQ" << "PMOVZXBW" << "PMOVZXDQ"
        << "PMOVZXWD" << "PMOVZXWQ" << "PMULDQ" << "PMULHRIW" << "PMULHRSW" << "PMULHRWA"
        << "PMULHRWC" << "PMULHUW" << "PMULHW" << "PMULLD" << "PMULLW" << "PMULUDQ"
        << "PMVGEZB" << "PMVLZB" << "PMVNZB" << "PMVZB" << "POP" << "POPA" << "POPAD"
        << "POPAW" << "POPCNT" << "POPF" << "POPFD" << "POPFQ" << "POPFW" << "POR"
        << "PREFETCH" << "PREFETCHT0" << "PREFETCHT1" << "PREFETCHT2" << "PREFETCHW"
        << "PSADBW" << "PSHUFB" << "PSHUFD" << "PSHUFHW" << "PSHUFLW" << "PSHUFW" << "PSIGNB"
        << "PSIGND" << "PSIGNW" << "PSLLD" << "PSLLDQ" << "PSLLQ" << "PSLLW" << "PSRAD"
        << "PSRAW" << "PSRLD" << "PSRLDQ" << "PSRLQ" << "PSRLW" << "PSUBB" << "PSUBD"
        << "PSUBQ" << "PSUBSB" << "PSUBSIW" << "PSUBSW" << "PSUBUSB" << "PSUBUSW" << "PSUBW"
        << "PSWAPD" << "PTEST" << "PUNPCKHBW" << "PUNPCKHDQ" << "PUNPCKHQDQ" << "PUNPCKHWD"
        << "PUNPCKLBW" << "PUNPCKLDQ" << "PUNPCKLQDQ" << "PUNPCKLWD" << "PUSH" << "PUSHA"
        << "PUSHAD" << "PUSHAW" << "PUSHF" << "PUSHFD" << "PUSHFQ" << "PUSHFW" << "PXOR"
        << "RCL" << "RCPPS" << "RCPSS" << "RCR" << "RDFSBASE" << "RDGSBASE" << "RDM"
        << "RDMSR" << "RDPMC" << "RDRAND" << "RDSEED" << "RDSHR" << "RDTSC" << "RDTSCP"
        << "RESB" << "RESD" << "RESDQ" << "RESO" << "RESQ" << "REST" << "RESW" << "RESY"
        << "RET" << "RETF" << "RETN" << "ROL" << "ROR" << "RORX" << "ROUNDPD" << "ROUNDPS"
        << "ROUNDSD" << "ROUNDSS" << "RSDC" << "RSLDT" << "RSM" << "RSQRTPS" << "RSQRTSS"
        << "RSTS" << "SAHF" << "SAL" << "SALC" << "SAR" << "SARX" << "SBB" << "SCASB"
        << "SCASD" << "SCASQ" << "SCASW" << "SETA" << "SETAE" << "SETB" << "SETBE" << "SETC"
        << "SETE" << "SETG" << "SETGE" << "SETL" << "SETLE" << "SETNA" << "SETNAE" << "SETNB"
        << "SETNBE" << "SETNC" << "SETNE" << "SETNG" << "SETNGE" << "SETNL" << "SETNLE"
        << "SETNO" << "SETNP" << "SETNS" << "SETNZ" << "SETO" << "SETP" << "SETPE" << "SETPO"
        << "SETS" << "SETZ" << "SFENCE" << "SGDT" << "SHL" << "SHLD" << "SHLX" << "SHR"
        << "SHRD" << "SHRX" << "SHUFPD" << "SHUFPS" << "SIDT" << "SKINIT" << "SLDT"
        << "SLWPCB" << "SMI" << "SMINT" << "SMINTOLD" << "SMSW" << "SQRTPD" << "SQRTPS"
        << "SQRTSD" << "SQRTSS" << "STAC" << "STC" << "STD" << "STGI" << "STI" << "STMXCSR"
        << "STOSB" << "STOSD" << "STOSQ" << "STOSW" << "STR" << "SUB" << "SUBPD" << "SUBPS"
        << "SUBSD" << "SUBSS" << "SVDC" << "SVLDT" << "SVTS" << "SWAPGS" << "SYSCALL"
        << "SYSENTER" << "SYSEXIT" << "SYSRET" << "TEST" << "TIMES" << "TZCNT" << "UCOMISD"
        << "UCOMISS" << "UD0" << "UD1" << "UD2" << "UD2A" << "UD2B" << "UMOV" << "UNPCKHPD"
        << "UNPCKHPS" << "UNPCKLPD" << "UNPCKLPS" << "VADDPD" << "VADDPS" << "VADDSD"
        << "VADDSS" << "VADDSUBPD" << "VADDSUBPS" << "VAESDEC" << "VAESDECLAST"
        << "VAESENCLAST" << "VAESIMC" << "VAESKEYGENASSIST" << "VANDNPD" << "VANDNPS"
        << "VANDPD" << "VANDPS" << "VBLENDPD" << "VBLENDPS" << "VBLENDVPD" << "VBLENDVPS"
        << "VBROADCASTF128" << "VBROADCASTI128" << "VBROADCASTSD" << "VBROADCASTSS"
        << "VCMPEQ_OSPD" << "VCMPEQ_OSPS" << "VCMPEQ_OSSD" << "VCMPEQ_OSSS" << "VCMPEQPD"
        << "VCMPEQPS" << "VCMPEQSD" << "VCMPEQSS" << "VCMPEQ_UQPD" << "VCMPEQ_UQPS"
        << "VCMPEQ_UQSD" << "VCMPEQ_UQSS" << "VCMPEQ_USPD" << "VCMPEQ_USPS" << "VCMPEQ_USSD"
        << "VCMPEQ_USSS" << "VCMPFALSE_OQPD" << "VCMPFALSE_OQPS" << "VCMPFALSE_OQSD"
        << "VCMPFALSE_OQSS" << "VCMPFALSE_OSPD" << "VCMPFALSE_OSPS" << "VCMPFALSE_OSSD"
        << "VCMPFALSE_OSSS" << "VCMPFALSEPD" << "VCMPFALSEPS" << "VCMPFALSESD"
        << "VCMPFALSESS" << "VCMPGE_OQPD" << "VCMPGE_OQPS" << "VCMPGE_OQSD" << "VCMPGE_OQSS"
        << "VCMPGE_OSPD" << "VCMPGE_OSPS" << "VCMPGE_OSSD" << "VCMPGE_OSSS" << "VCMPGEPD"
        << "VCMPGEPS" << "VCMPGESD" << "VCMPGESS" << "VCMPGT_OQPD" << "VCMPGT_OQPS"
        << "VCMPGT_OQSD" << "VCMPGT_OQSS" << "VCMPGT_OSPD" << "VCMPGT_OSPS" << "VCMPGT_OSSD"
        << "VCMPGT_OSSS" << "VCMPGTPD" << "VCMPGTPS" << "VCMPGTSD" << "VCMPGTSS"
        << "VCMPLE_OQPD" << "VCMPLE_OQPS" << "VCMPLE_OQSD" << "VCMPLE_OQSS" << "VCMPLE_OSPD"
        << "VCMPLE_OSPS" << "VCMPLE_OSSD" << "VCMPLE_OSSS" << "VCMPLEPD" << "VCMPLEPS"
        << "VCMPLESD" << "VCMPLESS" << "VCMPLT_OQPD" << "VCMPLT_OQPS" << "VCMPLT_OQSD"
        << "VCMPLT_OQSS" << "VCMPLT_OSPD" << "VCMPLT_OSPS" << "VCMPLT_OSSD" << "VCMPLT_OSSS"
        << "VCMPLTPD" << "VCMPLTPS" << "VCMPLTSD" << "VCMPLTSS" << "VCMPNEQ_OQPD"
        << "VCMPNEQ_OQPS" << "VCMPNEQ_OQSD" << "VCMPNEQ_OQSS" << "VCMPNEQ_OSPD"
        << "VCMPNEQ_OSPS" << "VCMPNEQ_OSSD" << "VCMPNEQ_OSSS" << "VCMPNEQPD" << "VCMPNEQPS"
        << "VCMPNEQSD" << "VCMPNEQSS" << "VCMPNEQ_UQPD" << "VCMPNEQ_UQPS" << "VCMPNEQ_UQSD"
        << "VCMPNEQ_UQSS" << "VCMPNEQ_USPD" << "VCMPNEQ_USPS" << "VCMPNEQ_USSD"
        << "VCMPNEQ_USSS" << "VCMPNGEPD" << "VCMPNGEPS" << "VCMPNGESD" << "VCMPNGESS"
        << "VCMPNGE_UQPD" << "VCMPNGE_UQPS" << "VCMPNGE_UQSD" << "VCMPNGE_UQSS"
        << "VCMPNGE_USPD" << "VCMPNGE_USPS" << "VCMPNGE_USSD" << "VCMPNGE_USSS"
        << "VCMPNGTPD" << "VCMPNGTPS" << "VCMPNGTSD" << "VCMPNGTSS" << "VCMPNGT_UQPD"
        << "VCMPNGT_UQPS" << "VCMPNGT_UQSD" << "VCMPNGT_UQSS" << "VCMPNGT_USPD"
        << "VCMPNGT_USPS" << "VCMPNGT_USSD" << "VCMPNGT_USSS" << "VCMPNLEPD"
        << "VCMPNLEPS" << "VCMPNLESD" << "VCMPNLESS" << "VCMPNLE_UQPD" << "VCMPNLE_UQPS"
        << "VCMPNLE_UQSD" << "VCMPNLE_UQSS" << "VCMPNLE_USPD" << "VCMPNLE_USPS"
        << "VCMPNLE_USSD" << "VCMPNLE_USSS" << "VCMPNLTPD" << "VCMPNLTPS" << "VCMPNLTSD"
        << "VCMPNLTSS" << "VCMPNLT_UQPD" << "VCMPNLT_UQPS" << "VCMPNLT_UQSD" << "VCMPNLT_UQSS"
        << "VCMPNLT_USPD" << "VCMPNLT_USPS" << "VCMPNLT_USSD" << "VCMPNLT_USSS"
        << "VCMPORDPD" << "VCMPORDPS" << "VCMPORD_QPD" << "VCMPORD_QPS" << "VCMPORD_QSD"
        << "VCMPORD_QSS" << "VCMPORDSD" << "VCMPORD_SPD" << "VCMPORD_SPS" << "VCMPORDSS"
        << "VCMPORD_SSD" << "VCMPORD_SSS" << "VCMPPD" << "VCMPPS" << "VCMPSD" << "VCMPSS"
        << "VCMPTRUEPD" << "VCMPTRUEPS" << "VCMPTRUESD" << "VCMPTRUESS" << "VCMPTRUE_UQPD"
        << "VCMPTRUE_UQPS" << "VCMPTRUE_UQSD" << "VCMPTRUE_UQSS" << "VCMPTRUE_USPD"
        << "VCMPTRUE_USPS" << "VCMPTRUE_USSD" << "VCMPTRUE_USSS" << "VCMPUNORDPD"
        << "VCMPUNORDPS" << "VCMPUNORD_QPD" << "VCMPUNORD_QPS" << "VCMPUNORD_QSD"
        << "VCMPUNORD_QSS" << "VCMPUNORDSD" << "VCMPUNORD_SPD" << "VCMPUNORD_SPS"
        << "VCMPUNORDSS" << "VCMPUNORD_SSD" << "VCMPUNORD_SSS" << "VCOMISD" << "VCOMISS"
        << "VCVTDQ2PD" << "VCVTDQ2PS" << "VCVTPD2DQ" << "VCVTPD2PS" << "VCVTPH2PS"
        << "VCVTPS2DQ" << "VCVTPS2PD" << "VCVTPS2PH" << "VCVTSD2SI" << "VCVTSD2SS"
        << "VCVTSI2SD" << "VCVTSI2SS" << "VCVTSS2SD" << "VCVTSS2SI" << "VCVTTPD2DQ"
        << "VCVTTPS2DQ" << "VCVTTSD2SI" << "VCVTTSS2SI" << "VDIVPD" << "VDIVPS"
        << "VDIVSD" << "VDIVSS" << "VDPPD" << "VDPPS" << "VERR" << "VERW" << "VEXTRACTF128"
        << "VEXTRACTI128" << "VEXTRACTPS" << "VFMADD123PD" << "VFMADD123PS" << "VFMADD123SD"
        << "VFMADD123SS" << "VFMADD132PD" << "VFMADD132PS" << "VFMADD132SD" << "VFMADD132SS"
        << "VFMADD213PD" << "VFMADD213PS" << "VFMADD213SD" << "VFMADD213SS" << "VFMADD231PD"
        << "VFMADD231PS" << "VFMADD231SD" << "VFMADD231SS" << "VFMADD312PD" << "VFMADD312PS"
        << "VFMADD312SD" << "VFMADD312SS" << "VFMADD321PD" << "VFMADD321PS" << "VFMADD321SD"
        << "VFMADD321SS" << "VFMADDPD" << "VFMADDPS" << "VFMADDSD" << "VFMADDSS"
        << "VFMADDSUB123PD" << "VFMADDSUB123PS" << "VFMADDSUB132PD" << "VFMADDSUB132PS"
        << "VFMADDSUB213PD" << "VFMADDSUB213PS" << "VFMADDSUB231PD" << "VFMADDSUB231PS"
        << "VFMADDSUB312PD" << "VFMADDSUB312PS" << "VFMADDSUB321PD" << "VFMADDSUB321PS"
        << "VFMADDSUBPD" << "VFMADDSUBPS" << "VFMSUB123PD" << "VFMSUB123PS" << "VFMSUB123SD"
        << "VFMSUB123SS" << "VFMSUB132PD" << "VFMSUB132PS" << "VFMSUB132SD" << "VFMSUB132SS"
        << "VFMSUB213PD" << "VFMSUB213PS" << "VFMSUB213SD" << "VFMSUB213SS" << "VFMSUB231PD"
        << "VFMSUB231PS" << "VFMSUB231SD" << "VFMSUB231SS" << "VFMSUB312PD" << "VFMSUB312PS"
        << "VFMSUB312SD" << "VFMSUB312SS" << "VFMSUB321PD" << "VFMSUB321PS" << "VFMSUB321SD"
        << "VFMSUB321SS" << "VFMSUBADD123PD" << "VFMSUBADD123PS" << "VFMSUBADD132PD"
        << "VFMSUBADD132PS" << "VFMSUBADD213PD" << "VFMSUBADD213PS" << "VFMSUBADD231PD"
        << "VFMSUBADD231PS" << "VFMSUBADD312PD" << "VFMSUBADD312PS" << "VFMSUBADD321PD"
        << "VFMSUBADD321PS" << "VFMSUBADDPD" << "VFMSUBADDPS" << "VFMSUBPD" << "VFMSUBPS"
        << "VFMSUBSD" << "VFMSUBSS" << "VFNMADD123PD" << "VFNMADD123PS" << "VFNMADD123SD"
        << "VFNMADD123SS" << "VFNMADD132PD" << "VFNMADD132PS" << "VFNMADD132SD"
        << "VFNMADD132SS" << "VFNMADD213PD" << "VFNMADD213PS" << "VFNMADD213SD"
        << "VFNMADD213SS" << "VFNMADD231PD" << "VFNMADD231PS" << "VFNMADD231SD"
        << "VFNMADD231SS" << "VFNMADD312PD" << "VFNMADD312PS" << "VFNMADD312SD"
        << "VFNMADD312SS" << "VFNMADD321PD" << "VFNMADD321PS" << "VFNMADD321SD"
        << "VFNMADD321SS" << "VFNMADDPD" << "VFNMADDPS" << "VFNMADDSD" << "VFNMADDSS"
        << "VFNMSUB123PD" << "VFNMSUB123PS" << "VFNMSUB123SD" << "VFNMSUB123SS"
        << "VFNMSUB132PD" << "VFNMSUB132PS" << "VFNMSUB132SD" << "VFNMSUB132SS"
        << "VFNMSUB213PD" << "VFNMSUB213PS" << "VFNMSUB213SD" << "VFNMSUB213SS"
        << "VFNMSUB231PD" << "VFNMSUB231PS" << "VFNMSUB231SD" << "VFNMSUB231SS"
        << "VFNMSUB312PD" << "VFNMSUB312PS" << "VFNMSUB312SD" << "VFNMSUB312SS"
        << "VFNMSUB321PD" << "VFNMSUB321PS" << "VFNMSUB321SD" << "VFNMSUB321SS"
        << "VFNMSUBPD" << "VFNMSUBPS" << "VFNMSUBSD" << "VFNMSUBSS" << "VFRCZPD"
        << "VFRCZPS" << "VFRCZSD" << "VFRCZSS" << "VGATHERDPD" << "VGATHERDPS" << "VGATHERQPD"
        << "VGATHERQPS" << "VHADDPD" << "VHADDPS" << "VHSUBPD" << "VHSUBPS" << "VINSERTF128"
        << "VINSERTI128" << "VINSERTPS" << "VLDDQU" << "VLDMXCSR" << "VLDQQU" << "VMASKMOVDQU"
        << "VMASKMOVPD" << "VMASKMOVPS" << "VMAXPD" << "VMAXPS" << "VMAXSD" << "VMAXSS"
        << "VMCLEAR" << "VMFUNC" << "VMINPD" << "VMINPS" << "VMINSD" << "VMINSS" << "VMLAUNCH"
        << "VMLOAD" << "VMMCALL" << "VMOVAPD" << "VMOVAPS" << "VMOVD" << "VMOVDDUP"
        << "VMOVDQA" << "VMOVDQU" << "VMOVHLPS" << "VMOVHPD" << "VMOVHPS" << "VMOVLHPS"
        << "VMOVLPD" << "VMOVLPS" << "VMOVMSKPD" << "VMOVMSKPS" << "VMOVNTDQ" << "VMOVNTDQA"
        << "VMOVNTPD" << "VMOVNTPS" << "VMOVNTQQ" << "VMOVQ" << "VMOVQQA" << "VMOVQQU"
        << "VMOVSD" << "VMOVSHDUP" << "VMOVSLDUP" << "VMOVSS" << "VMOVUPD" << "VMOVUPS"
        << "VMPSADBW" << "VMPTRLD" << "VMPTRST" << "VMREAD" << "VMRESUME" << "VMRUN"
        << "VMSAVE" << "VMULPD" << "VMULPS" << "VMULSD" << "VMULSS" << "VMWRITE" << "VMXOFF"
        << "VMXON" << "VORPD" << "VORPS" << "VPABSB" << "VPABSD" << "VPABSW" << "VPACKSSDW"
        << "VPACKSSWB" << "VPACKUSDW" << "VPACKUSWB" << "VPADDB" << "VPADDD" << "VPADDQ"
        << "VPADDSB" << "VPADDSW" << "VPADDUSB" << "VPADDUSW" << "VPADDW" << "VPALIGNR"
        << "VPAND" << "VPANDN" << "VPAVGB" << "VPAVGW" << "VPBLENDD" << "VPBLENDVB"
        << "VPBLENDW" << "VPBROADCASTB" << "VPBROADCASTD" << "VPBROADCASTQ" << "VPBROADCASTW"
        << "VPCLMULHQHQDQ" << "VPCLMULHQLQDQ" << "VPCLMULLQHQDQ" << "VPCLMULQDQ" << "VPCMOV"
        << "VPCMPEQB" << "VPCMPEQD" << "VPCMPEQQ" << "VPCMPEQW" << "VPCMPESTRI"
        << "VPCMPESTRM" << "VPCMPGTB" << "VPCMPGTD" << "VPCMPGTQ" << "VPCMPGTW"
        << "VPCMPISTRI" << "VPCMPISTRM" << "VPCOMB" << "VPCOMD" << "VPCOMQ" << "VPCOMUB"
        << "VPCOMUD" << "VPCOMUQ" << "VPCOMUW" << "VPCOMW" << "VPERM2F128" << "VPERM2I128"
        << "VPERMD" << "VPERMILPD" << "VPERMILPS" << "VPERMPD" << "VPERMPS" << "VPERMQ"
        << "VPEXTRB" << "VPEXTRD" << "VPEXTRQ" << "VPEXTRW" << "VPGATHERDD" << "VPGATHERDQ"
        << "VPGATHERQD" << "VPGATHERQQ" << "VPHADDBD" << "VPHADDBQ" << "VPHADDBW"
        << "VPHADDD" << "VPHADDDQ" << "VPHADDSW" << "VPHADDUBD" << "VPHADDUBQ" << "VPHADDUBW"
        << "VPHADDUDQ" << "VPHADDUWD" << "VPHADDUWQ" << "VPHADDW" << "VPHADDWD" << "VPHADDWQ"
        << "VPHMINPOSUW" << "VPHSUBBW" << "VPHSUBD" << "VPHSUBDQ" << "VPHSUBSW" << "VPHSUBW"
        << "VPHSUBWD" << "VPINSRB" << "VPINSRD" << "VPINSRQ" << "VPINSRW" << "VPMACSDD"
        << "VPMACSDQH" << "VPMACSDQL" << "VPMACSSDD" << "VPMACSSDQH" << "VPMACSSDQL"
        << "VPMACSSWD" << "VPMACSSWW" << "VPMACSWD" << "VPMACSWW" << "VPMADCSSWD"
        << "VPMADCSWD" << "VPMADDUBSW" << "VPMADDWD" << "VPMASKMOVD" << "VPMASKMOVQ"
        << "VPMAXSB" << "VPMAXSD" << "VPMAXSW" << "VPMAXUB" << "VPMAXUD" << "VPMAXUW"
        << "VPMINSB" << "VPMINSD" << "VPMINSW" << "VPMINUB" << "VPMINUD" << "VPMINUW"
        << "VPMOVMSKB" << "VPMOVSXBD" << "VPMOVSXBQ" << "VPMOVSXBW" << "VPMOVSXDQ"
        << "VPMOVSXWD" << "VPMOVSXWQ" << "VPMOVZXBD" << "VPMOVZXBQ" << "VPMOVZXBW"
        << "VPMOVZXDQ" << "VPMOVZXWD" << "VPMOVZXWQ" << "VPMULDQ" << "VPMULHRSW" << "VPMULHUW"
        << "VPMULHW" << "VPMULLD" << "VPMULLW" << "VPMULUDQ" << "VPOR" << "VPPERM" << "VPROTB"
        << "VPROTD" << "VPROTQ" << "VPROTW" << "VPSADBW" << "VPSHAB" << "VPSHAD" << "VPSHAQ"
        << "VPSHAW" << "VPSHLB" << "VPSHLD" << "VPSHLQ" << "VPSHLW" << "VPSHUFB" << "VPSHUFD"
        << "VPSHUFHW" << "VPSHUFLW" << "VPSIGNB" << "VPSIGND" << "VPSIGNW" << "VPSLLD"
        << "VPSLLDQ" << "VPSLLQ" << "VPSLLVD" << "VPSLLVQ" << "VPSLLW" << "VPSRAD"
        << "VPSRAVD" << "VPSRAW" << "VPSRLD" << "VPSRLDQ" << "VPSRLQ" << "VPSRLVD"
        << "VPSRLVQ" << "VPSRLW" << "VPSUBB" << "VPSUBD" << "VPSUBQ" << "VPSUBSB" << "VPSUBSW"
        << "VPSUBUSB" << "VPSUBUSW" << "VPSUBW" << "VPTEST" << "VPUNPCKHBW" << "VPUNPCKHDQ"
        << "VPUNPCKHQDQ" << "VPUNPCKHWD" << "VPUNPCKLBW" << "VPUNPCKLDQ" << "VPUNPCKLQDQ"
        << "VPUNPCKLWD" << "VPXOR" << "VRCPPS" << "VRCPSS" << "VROUNDPD" << "VROUNDPS"
        << "VROUNDSD" << "VROUNDSS" << "VRSQRTPS" << "VRSQRTSS" << "VSHUFPD" << "VSHUFPS"
        << "VSQRTPD" << "VSQRTPS" << "VSQRTSD" << "VSQRTSS" << "VSTMXCSR" << "VSUBPD"
        << "VSUBPS" << "VSUBSD" << "VSUBSS" << "VTESTPD" << "VTESTPS" << "VUCOMISD"
        << "VUCOMISS" << "VUNPCKHPD" << "VUNPCKHPS" << "VUNPCKLPD" << "VUNPCKLPS"
        << "VXORPD" << "VXORPS" << "VZEROALL" << "VZEROUPPER" << "WBINVD" << "WRFSBASE"
        << "WRGSBASE" << "WRMSR" << "WRSHR" << "XABORT" << "XADD" << "XBEGIN" << "XBTS"
        << "XCHG" << "XCRYPTCBC" << "XCRYPTCFB" << "XCRYPTCTR" << "XCRYPTECB" << "XCRYPTOFB"
        << "XEND" << "XLAT" << "XLATB" << "XOR" << "XORPD" << "XORPS" << "XRSTOR"
        << "XRSTOR64" << "XSAVE" << "XSAVE64" << "XSAVEOPT" << "XSAVEOPT64" << "XSETBV"
        << "XSHA1" << "XSHA256" << "XTEST" << "SECTION" << "SEGMENT" << "EXTERN" << "GLOBAL";
}

static Instructions ins;
